=== debian/changelog ===
ikos (3.5-2build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:27:23 +0200

ikos (3.5-2) unstable; urgency=medium

  * Link with libatomic on armel

 -- Scott Talbert <swt@techie.net>  Thu, 03 Apr 2025 19:51:28 -0400

ikos (3.5-1) unstable; urgency=medium

  * Update to new upstream release 3.5
  * Update Standards-Version to 4.7.2

 -- Scott Talbert <swt@techie.net>  Sat, 29 Mar 2025 13:25:14 -0400
